/*
 * ShowVTaggedEvent.cpp -- Reads and displays tagged Vevents events written to 
 * a VEvent file.
 * uses the datum_file_handle produced by by Filip Pizlo, 2002
 * Written by Glenn Sembroski 04/02/02
 */

#include "datum_file_handler.h"
#include "VTaggedEvent.h"
#include "VTaggedEventD.h"
#include <cassert>
#include <iostream>
using namespace std;

void ReadTaggedVevent() {
  VTaggedEventD EventD;
  VDatumFileReader *in=VDatumFileReader::openFile("VEvent.dat");
  assert(in!=NULL);
  for(int k=0;k<10000;k++)
    {
      //Read next event.
      VTaggedEvent *ev=(VTaggedEvent*)in->readDatum(new VTaggedEvent());
      assert(ev!=NULL);
      EventD.setTaggedEvent(ev);
      cout<<endl;
      EventD.getTags();
      cout<<"Energy(TeV):"<<EventD.getShowerEnergyTev()<<"Shower Id:"<<
	EventD.getShowerId()<<" Type:"<<EventD.getShowerType()<<
	" Itheta,Iphi:"<<EventD.getMountITheta()<<","<<
	EventD.getMountIPhi()<<" Mount X,Y:"<<EventD.getMountLocationX()
	  <<","<<EventD.getMountLocationY()<<" Shower Max:"<<
	EventD.getShowerMax()<<endl;
      cout<<"Length,NumSamples,Numchannels:"<<EventD.getEventLength()<<
	","<<EventD.getNumSamples()<<","<<EventD.getNumChannels()<<endl;
      word32 hits[500];
      word32 trigger[500];
      word32 hiLo[500];
      for(int i=0;i<499;i++)
	{
	  word32 m=i+1;
	  if(EventD.isChannelHit(m))
	    hits[i]=1;
	  else
	    hits[i]=0;
	  if(EventD.isChannelHiLo(m))
	    hiLo[i]=1;
	  else
	    hiLo[i]=0;
	  if(EventD.isChannelTrigger(m))
	    trigger[i]=1;
	  else
	    trigger[i]=0;
	}
      int n;
      for(int i=0;i<10;i++)
	{
	  cout<<endl;
	  n=i*50;
	  cout<<"Hits:"<<n<<":";
	  for(int m=0;m<50;m++)
	    {
	      cout<<hits[n];
	      n++;
	    }
	  cout<<endl;
	  
	  n=i*50;
	  cout<<"HiLo:"<<n<<":";
	  for(int m=0;m<50;m++)
	    {
	      cout<<hiLo[n];
	      n++;
	    }
	  cout<<endl;
	  
	  n=i*50;
	  cout<<"Trig:"<<n<<":";
	  for(int m=0;m<50;m++)
	    {
	      cout<<trigger[n];
	      n++;
	    }
	  cout<<endl;
	}
      
      for (int i=0;i<EventD.getNumChannels();i++) {
	int channel=EventD.getChannelNum(i);
	int ped=EventD.getFadcPedestal(i);
	int charge=EventD.getFadcCharge(i);
	int value=charge-ped;
	cout<<" Index:FadcChannel,Pedestal,Charge,Value:"<<i<<":"<<channel<<
	  ","<<ped<<","<<charge<<","<<value<<endl;
	/*
	byte* Samples=EventD.getFadcSamples(i);
	cout<<"Fadc:";
	for(int m=0; m<EventD.getNumSamples();m++)
	  
	  cout<<(word32)Samples[m];
	cout<<":"<<hits[i]<<hiLo[i]<<trigger[i];
	cout<<endl;
	*/
      }
      delete ev;
      int gtemp;
      cout<<"Next event?";
      cin >> gtemp;
    }
  delete in;
}

int main() {
  ReadTaggedVevent();
  return 0;
}

