#include "VEvent.h"
   
bool VEvent::GetStatus(int FlagNumber)
{
  if(a.fStatus & int (1 << FlagNumber)) //(1 << i) Makes an int with bit 1 
    return true;                        //shifted over i places. i=0 tests 
  else                                  //lowest bit.
    return false;
}

void  VEvent::SetStatus(bool flagValue, int FlagNumber)
{
  if (flagValue)
      a.fStatus |= int (1 << FlagNumber);//Or in the bit to set.
  else
    {                                    //Make an int all bits on except
      int nstatus=(~int(1<<FlagNumber)); //for bit FlagNumber. XOR here will
      a.fStatus ^= nstatus;              //clear it in a.fStatus
    }
  return ;                              
}
 
void  VEvent::GetGPSTime(int* timeGPS)
{
  for (int i=0;i<5; i++)               //This is really a place saver for a 
    {                                  //more involved function for converting
      timeGPS[i]=a.fGPSTime[i];        //the raw GPS values to someting useful,
    }                                  //(like Julian day).
  return;
}
void  VEvent::PutGPSTime(int* timeGPS)
{
  for (int i=0;i<5; i++)               //This is really a place saver for a 
    {                                  //more involved function for converting
      a.fGPSTime[i]=timeGPS[i];        //a time in Julian day to the raw GPS 
    }                                  //values.
  return;
}

bool VEvent::GetFadcIndex(int channel, int fadcIndex)
{
  if(a.fChannelHits.IsBitOn(channel))  //Is this channel in the data?
     {
       for(fadcIndex=0;fadcIndex<fNumberFadcHits,i++) //Search for it
	 {
	   if(a.FadcData[fadcIndex].GetChannelId == channel)
	     return true;
	 }
     }
  fadc_index=-1;
  return false;
}

bool VEvent::GetFadcSamples(int channel, int* samples)
{
  if(GetFadcIndex(channel,int fadcIndex))
    {
      a.fFadcData[fadcIndex].GetFadc(samples);
      return true;
    }
  return false;
}



bool VEvent::GetFadcPedestal(int channel, int pedestal)
{
    if(GetFadcIndex(channel,int fadcIndex))
      {
	pedestal=a.fFadcData[fadcIndex].GetPedestal();
	return true;
      }
    return false;
}

bool VEvent::GetFadcCharge(int channel, int charge)
{
    if(GetFadcIndex(channel,int fadcIndex))
      {
	charge=a.fFadcData[fadcIndex].GetCharge();
	return true;
      }
    return false;
}

//VPattern Member funciton
bool VPattern::IsBitOn(int channel)
{
  int iword=int(channel-1/sizeof(int)*8); //channels start at 1. thus channel
                                          // 33 would be in word 1 (not 0)
  int ibit=(channel-1)-iword*sizeof(int)*8; // Bit in word.Starting at 0
  if(fPattern[iword] & int (1<<ibit) )      //see (1<<i) makes word with bit i
    {
      return true;                            //only set.
    }
  return false;
}          

void VPattern::SetBit(int channel)
{    
  int iword=int(channel-1/sizeof(int)*8); //channels start at 1. thus channel
                                          // 33 would be in word 1 (not 0)
  int ibit=(channel-1)-iword*sizeof(int)*8; // Bit in word.Starting at 0
  fPattern[iword] |= int (1 << ibit);   //Or in the bit to set.
  return;
}

void VPattern::ClearBit(int channel)
{    
  int iword=int(channel-1/sizeof(int)*8);   //channels start at 1. thus channel
                                            // 33 would be in word 1 (not 0)
  int ibit=(channel-1)-iword*sizeof(int)*8; // Bit in word.Starting at 0
  int nstatus=(~int(1<<ibit));              //for bit ibit. XOR here will
  fPattern[iword] ^= nstatus;               //clear it.
  return;
}

void VFadcData::GetFadc(int* samples)
{
  for(int i=0;i<kFadcSamples;i++)
    samples[i]=int fFadcSamples[i];
  return;
}
void VFadcData::PutFadc(int* samples)
{
  for(int i=0;i<kFadcSamples;i++)
    fFadcSamples[i]=unsigned char samples[i];
  return;
}
