//VEventD.cpp.  Delegator for VEvent.
//!Upgraded to Revised datum.h 19/02/02 GHS.
#include "VEventD.h"
//****************************************************************************
//  VPattern member functions:
//**************************************************************************   

bool VPattern::isBitOn(word32 channel)
{           //Channels start at 1! Not ZERO!
  word32 iword=word32((channel-1)/(sizeof(word32)*8)); //channels start at 1. 
                                           //thus 33 would be in word 1 (not 0)
  word32 ibit=(channel-1)-(iword*sizeof(word32)*8); //Bit in word.Starting at 0
  unsigned long nstatus=(1<<ibit);         //for bit ibit. 
  unsigned long pattern;                   
  memcpy(&pattern,&f_Pattern[iword],sizeof(word32));
  if(pattern & nstatus )                  //see (1<<i) makes word with bit i
    {
      return true;                            //only set.
    }
  return false;
}          

void VPattern::setBit(word32 channel)
{    
  word32 iword=word32((channel-1)/(sizeof(word32)*8));//channels start at 1.
                                          // 33 would be in word 1 (not 0)
  word32 ibit=(channel-1)-(iword*sizeof(word32)*8); //Bit in word.Starting at 0
  unsigned long nstatus=(1<<ibit);         //for bit ibit. 
  unsigned long pattern;                   
  memcpy(&pattern,&f_Pattern[iword],sizeof(word32));
  pattern |= nstatus;                     //Or in the bit to set.
  memcpy(&f_Pattern[iword],&pattern,sizeof(word32));
  return;
}

void VPattern::clearBit(word32 channel)
{    
  word32 iword=word32((channel-1)/(sizeof(word32)*8));//channels start at 1. 
                                  //thus 33 would be in word 1 (not 0)
  word32 ibit=(channel-1)-(iword*sizeof(word32)*8);// Bit in word.Starting at 0
  unsigned long nstatus=(1<<ibit);         //for bit ibit. 
  nstatus=~nstatus;                        //Bitwise Compliment it.
  unsigned long pattern;                   
  memcpy(&pattern,&f_Pattern[iword],sizeof(word32));
  pattern &= nstatus;               //AND (&)here will clear it.
  memcpy(&f_Pattern[iword],&pattern,sizeof(word32));
  return;
}

void VPattern::initPattern(word32* parray)
{      
  f_Pattern=parray;
  int j=16;  //Number of word32 in patterns(512 bits)
  for (int i=0;i<j;i++)
    f_Pattern[i]=0;
  return;
}




//**************************************************************************   
//VEventD member functions:
//**************************************************************************   

void VEventD::setEvent(VEvent* Event)
{      
  f_Event=Event;
  f_ChannelHits.setPattern(f_Event->getHitPattern());
  f_ChannelTriggers.setPattern(f_Event->getTriggerPattern());
  f_ChannelHiLo.setPattern(f_Event->getHiLoPattern());
  word32 flags=0;
  f_Event->setFlags(flags);
  return;
}

bool VEventD::getStatus(word32 FlagNumber)
{
  if(f_Event->getFlags() & word32 (1 << FlagNumber)) 
                                        //(1 << i) Makes an word32 with bit 1 
    return true;                        //shifted over i places. i=0 tests 
  else                                  //lowest bit.
    return false;
}

void  VEventD::setStatus(bool flagValue, word32 FlagNumber)
{
  word32 flags=f_Event->getFlags();
  if (flagValue)
    flags |= word32 (1 << FlagNumber);    //Or in the bit to set.
  else
    {                                    //Make an word32 all bits on except
      word32 nstatus=(~word32(1<<FlagNumber)); //for bit FlagNumber. 
                                               //XOR here will
      flags ^= nstatus;                        //clear it in a.fStatus
    }
  f_Event->setFlags(flags);
  return ;                              
}
 
bool VEventD::getFadcIndex(word32 channel, word32 fadcIndex)
{           //Channels start at 1! Not ZERO!
  if(f_ChannelHits.isBitOn(channel))  //Is this channel in the data?
    {                                 //Search for it
      for(fadcIndex=0;fadcIndex<f_Event->getNumChannels();fadcIndex++) 
	{
	  if(f_Event->getChannelNum(fadcIndex) == channel)
	    return true;
	}
    }
  fadcIndex=-1;
  return false;
}




