//VTaggedEventD.h
//! Wrapper class for VTaggedEvent.

#ifndef V_TAGGED_EVENT_D_H
#define V_TAGGED_EVENT_D_H
#include "VEventD.h"
#include "VTaggedEvent.h"
/*! Wrapper class for VTaggedEvent. Derived from wrapper class VEventD. Just 
 *  extends things to add tagged data capability.
 */

class VTaggedEventD : public VEventD 
{

  protected:
  VTaggedEvent* f_TaggedEvent;
  
 public:
  VTaggedEventD(){};
  ~VTaggedEventD(){};
                           //Caller must always creates Event
  void setTaggedEvent(VTaggedEvent* taggedEvent){setEvent(taggedEvent); 
                                           f_TaggedEvent=taggedEvent;return;};
  word32 getEventLength(){return word32(f_Event->getLength());};

  void getTags(){f_TaggedEvent->getTags();return;};
  float getShowerEnergyTev(){return f_TaggedEvent->getShowerEnergyTev();};
  word32 getShowerId(){return f_TaggedEvent->getShowerId();};
  word32 getShowerType(){return f_TaggedEvent->getShowerType();};
  word32 getMountITheta(){return f_TaggedEvent->getMountITheta();};
  word32 getMountIPhi(){return f_TaggedEvent->getMountIPhi();};
  float getMountLocationX(){return f_TaggedEvent->getMountLocationX();};
  float getMountLocationY(){return f_TaggedEvent->getMountLocationY();};
  float getShowerMax(){return f_TaggedEvent->getShowerMax();};
  void setShowerEnergyTev(float energy)
    {f_TaggedEvent->setShowerEnergyTev(energy);return;};
  void setShowerId(word32 fileId){f_TaggedEvent->setShowerId(fileId);return;};
  void setMountITheta(word32 theta)
    {f_TaggedEvent->setMountITheta(theta);return;};
  void setMountIPhi(word32 phi){f_TaggedEvent->setMountIPhi(phi);return;};
  void setMountLocation(float x, float y)
    {f_TaggedEvent->setMountLocation(x,y); return;};
  void setShowerMax(float shwrMax)
    {f_TaggedEvent->setShowerMax(shwrMax);return;};
  void putTags(){f_TaggedEvent->putTags(); return;};
void setShowerType(word32 itype){f_TaggedEvent->setShowerType(itype);return;};
};
#endif //VTAGGED_EVENT_D_H
