    PROGRAM CMSUM_BIN2NTPL
!*****************************************************************************
!	Converts a binary hntp file(ouput from kasaomega) into a PAW ntupple.
!*****************************************************************************
!Modified:
!       22/11/02 GHS
!               Add the usde of input options -i (input file name) and -o
!               (output file name). If ouput file specified use it for nv=1
!               For nv>1 use outputfilename_nv.
!       03/03/04 GHS
!               Extend length of input command strigs to 120 characters.
 
	use structures

	IMPLICIT NONE

        type(h_ntp) :: hntp
	common/ntp/hntp		!For use writting out to the ntupple.
	integer :: nt=0,ntold=-10000000,icycle
	integer :: ios

	real,dimension(2000000) :: paw
	common /pawc/paw	!for ntuple creation
        character(len=120) :: cmsum_in_file = 'cmsum_in.dat'
        character(len=120) :: cmsum_out_file= 'cmsum_in.dat' !defalts to input 
                                                            !filename
        logical :: out_file_specified=.false.
        integer,external :: iargc
        integer :: num_cmd_args,i
        character(len=120) :: arg_opt

!******************************************************************************
!       Get ther various command line arguments.
!       All command line arguments come in pairs: An option (-p) and 
!                                                 a string (kasoam.par)
!       WE have 2 options for this program:
!           -i :Argument specifies input file(or a link to it)
!           -o :Argument specifies output file name.
!       Defaults are in wcamera_modules.f90
!******************************************************************************
!WARNING:Due to the fact that this program needs to be compiles with a -B108 option which adds a _ to all external names. We specify getarg_ as getarg(getarg
!comes from cern I think)
!******************************************************************************
        num_cmd_args=iargc()
        if(num_cmd_args.gt.0)then
           print*,'CMSUM_BIN2NTPL--Number of command line arguments:', &
                & num_cmd_args
           do i=1,num_cmd_args,2
              call getarg(i,arg_opt)
              arg_opt=trim(arg_opt)
              if(arg_opt=="-i")then
                 call getarg(i+1,cmsum_in_file)
                 cmsum_in_file=trim(cmsum_in_file)
                 print*,'-i option gives input file:',cmsum_in_file
                 cmsum_out_file=cmsum_in_file     !Default ouput name.
              elseif(arg_opt=="-o")then
                 call getarg(i+1,cmsum_out_file)
                 cmsum_out_file=trim(cmsum_out_file)
                 print*,'-o option gives output file:',cmsum_out_file
                 out_file_specified=.true.
              else
                 print*,' Illegal command line option #:',i,'Option:',arg_opt
                 stop 'CMSUM_BIN2NTPL: Illegal command line option'
              endif
           enddo
        else
           print*,' CMSUM_BIN2NTPL--No command line arguments.'
           print*,' CMSUM_BIN2NTPL--Using defaults for all.'
        endif

	call hlimit(2000000)	!Defines maximum total size of PAWC

			!Open in input file
	OPEN(1,ACCESS='sequential',STATUS='old',FORM='BINARY', &
		& file=cmsum_in_file,iostat=ios)
        if(ios>0)then
           print*,' error opening ',cmsum_in_file
           stop 'file open error:input data file'
        endif
			
	do 
	        read(1,iostat=ios)hntp
	        if(ios==-1)then
			nt=1
			call hcdir('//NTUPLE',' ')
			call hrout(nt,icycle,' ')
			call hldir(' ',' ')
			call hrend('NTUPLE')
			close (unit=1)
			stop cmsum_in_file
 		endif
	    	nt=1
!!Write out hillas parameters to CWN. !gets hntp through common block
	    	call ntuple_cwn_hillas(nt,ntold,cmsum_out_file, &
                     & out_file_specified)
						 
	enddo
    END	PROGRAM CMSUM_BIN2NTPL



    SUBROUTINE NTUPLE_CWN_HILLAS(nt,ntold,filename,output_file_specified)
!******************************************************************************
!	This routine enteres data from ARRAY HNTP into ntuple nt.
!******************************************************************************
!	This is the version that makes a column wide ntuple.
!	HNTP is put into a common block in calling routine.

!	Modified:

!	10/4/96 GHS
!
!		Increase max number of records to maximum zera allows
!		which is 64 k (default=32000)
!		Requires 'Q' option in HROPEN and setting of RZ variable
!		IQUEST(10) in RZ common are QUEST.
!		If this value is too small one gets the error:
!		      'RZOUT . Request exceeds quota'	
!		May also be able to increase record size to solve this kind
!		of problem.
!		PAW FAQ says:
!PAW FAQ !!!!!!!!!!!!!!!!!!!!!!!!
!cIt may happen with the current versions of HBOOK/PAW that large ntuples
!cgive problems if the following process is not followed. To create large Ntuple
!cfiles, you can : 
!c
!cCALL HROPEN with a large value of LRECL (ex LRECL=4096 instead of
!c1024) and you can get files 4 times bigger.
!c
!cWhen you do that, do not forget in PAW (in Hi/File) to specify the LRECL
!cparameter.
!c
!cIf changing LRECL is not sufficient, you can also specify the option Q in
!cCHOPT and in IQUEST(10) (COMMON/QUEST/IQUEST(100)) give the
!cmaximum number of records (current default is 32000 records in CERNLIB
!c94A)
!c
!cExample: 
!c
!c    COMMON/QUEST/IQUEST(100)
!c    IQUEST(10)=64000
!c    CALL HROPEN(lun,......,'NQ',4096,istat)
!c
!cwill create a file with a maximum of 64000 records of 4096 words.
!cTo minimize the number of keys in the HBOOK/RZ directory, you can also
!cincrease the buffer size for your ntuple.
!cIf it is a CWN created by HBNT/HBNAME
!cSet the buffer size for each column via CALL HBSET('BSIZE',nwords) A
!cconvenient value for nwords is the record size itself (eg,4096 words)
!cPAW FAQ !!!!!!!!!!!!!!!!!!!!!!!!

!	12/2/98 GHS	Convert to F90

!	24/6/98 GHS V:1:1:5:1:2:1.2
!		Modify NTUPLE_CWN_HILLAS to limit size of ntuple files
!		to 2000000 events(1000000 blocks). Each new file' name ends
!		with *.*_v1,*.*_v2 etc.  Do this to avoid some PAW problems
!		with really big ntupples. Also makes it easier to put on tape.

!	25/6/98 GHS V:1:1:5:1:2:1.2
!		Put in a test so that when we make a new ntupple file we don't
!		split up a shower doing it. That caused problems in
!		KAS_ARRAY_TRIGGER

!	29/6/99 GHS V:1:1:5:1:2:1.7
!		Replace the use of the VMS system call lib$get_symbol with
!		the CERN lib call to GETENVF. This is a call that interfaces
!		with the C routine GETENV. Do this to provide protability to 
!		UNIX/LINUX. Changes to NTUPLE_CWN_HILLAS and to IMAGE.F90 also.!       22/11/02 GHS
!               Add the usde of input options -i (input file name) and -o
!               (output file name). If ouput file specified use it for nv=1
!               For nv>1 use outputfilename_nv. Add output_file_specified
!               to this routines argument list   
!       16/05/03 GHS
!               Fix use of namefile (add trim stuff).

	use structures
	IMPLICIT NONE

	integer :: nt,ntold,itfirst=0

	real,dimension(h_ntp_size) ::  ntp_h
	type(h_ntp) :: hntp
	common/ntp/hntp
	equivalence (ntp_h,hntp)

	integer,dimension(100) :: iquest
	common/quest/iquest

	real,dimension(2000000) :: paw
	common /pawc/paw	!for ntuple creation

	integer :: lrec=4096,lsize,ifirst,istat,icycle,i
	integer :: nt_count,nv,idold,nchar
	integer,parameter :: nt_count_max=2000000
	character(len=120) :: namefile
	character(*) :: filename
        character(len=120) :: nv_char
        logical :: output_file_specified

	if(itfirst.eq.0) then
           iquest(10)=64*1024-1	!Set max number of records in ntupple
					!file. Default is 32000 blocks.
!	Open the ouput file.(These are all hbook commands.)
           if(.not.output_file_specified)then   !Make up a name.
			!Get string value of 'base' name
              nchar=index(trim(filename),'.')
              if(nchar==0)then
                 nchar=len(trim(filename))
              endif

              nv=1
              write(nv_char,1000)nv
1000	format(i1)
              namefile=filename(1:nchar-1)//"_n.d0"//nv_char
           else
              namefile=trim(filename)
           endif

!debug
!          lrec=1024
           call hropen(4,'NTUPLE',trim(namefile),'NQ',lrec,istat)
					!Open unit 4, with arbitrary 
					!HBOOK name:'ntuple'
					!file name from 'p2'
					!File is 'N'ew file
					!1024=lrec.Block size(recomended)
!Funny CERN HROPEn-HBOOK thing: filename must be all lower case including any
!specified path.
		if(istat.ne.0)then
                   print*,'CMSUM_BIN2NTPL--Fatal--Failure to open output&
                        & ntupple file:', trim(namefile),' ios:',istat
		   print*,'CERN-HROPEN requires filename (including any &
                        &specified path) to be all lowercase!'
                   stop 'Failure to open output Ntupple file'
		else
			print*,' Hillas NTUPLE opened OK!:',trim(namefile)
			itfirst=1
			idold=0
		endif
	endif

	if(nt.ne.ntold)then
		if(ntold.gt.-1000000)then
			call hrout(ntold,icycle,' ')
			call hcdir('//PAWC',' ')
			call hdelet(ntold)
		endif
!		Define the variables.
!		For now h_ntp is all real, so its easy, but if we need to
!		go to Integers or logicals we can do that here also.
!		Also we could compress it here also with a little work, but
!		not now.(see hbook manual pg.24-27)

		call hcdir('//NTUPLE',' ')
		call hbnt(nt,'PES',' ')
		do i=1,h_ntp_size
			call hbname(nt,'H_NTP',ntp_h(i), &
					 &   tags_h_ntp(i)//':R')
					!ntuple id is nt
					!Block Name is 'H_NTP'
					!Tags_h_ntp=names of the varables
					!assumed to all be real, no compression
		enddo
		ntold=nt
		nt_count=0
	endif
	
	if(nt_count>=nt_count_max)then		!time to close this file and
						!open a new one.
 		if(idold==0)then		!But wait until we finish this
						!shower
			idold=hntp%id
		elseif(hntp%id/=idold)then	!Test for the new one.
		       	call hrout(ntold,icycle,' ')
		       	call hcdir('//PAWC',' ')
		       	call hdelet(ntold)
			call hrend('NTUPLE')
			close(unit=4)

			nv=nv+1
			if(nv<10)then
				write(nv_char,1000)nv
			else
				write(nv_char,1001)nv
1001	format(i2)
			endif
                        namefile=trim(filename)//"_"//nv_char

                        call hropen(4,'NTUPLE',namefile,'NQ',lrec,istat)
					!Open unit 4, with arbitrary 
					!HBOOK name:'ntuple'
					!file name from 'p2'
					!File is 'N'ew file
					!1024=lrec.Block size(recomended)
			if(istat.ne.0)then
				print*,' istat:',istat
				print*,' nv:',nv
                                print*,' namefile:',namefile
				stop 'hropen problem'
			else
			print*,' Hillas NTUPLE opened OK! File version#v',nv
				itfirst=1
			endif
				!define new file
			call hcdir('//NTUPLE',' ')
			call hbnt(nt,'PES',' ')
			do i=1,h_ntp_size
				call hbname(nt,'H_NTP',ntp_h(i), &
					 &   tags_h_ntp(i)//':R')
			enddo
			idold=0
			nt_count=0
		endif
	endif



		!	Enter this image
	call hfnt(nt)
	nt_count=nt_count+1
	return
    END SUBROUTINE NTUPLE_CWN_HILLAS
!******************************************************************************










