
MODULE IMAGE

!Image ntupple 1 definition(Camera definition). Suitable for all cameras(up to
! maxpmts pixels). All this to interface correctly with NT_CWN routine.
	integer,parameter :: maxpmts=1024
	character(LEN=4),parameter :: cmaxpmts='1024'
	integer,parameter :: maxneighbors=8
	character(LEN=1),parameter :: cmaxneighbors='8'

	common/c_im/npmts_c,camera_c,xseg_c,yseg_c,xoff_c,yoff_c,&
	&x_c(maxpmts),y_c(maxpmts),&
	&rad_c(maxpmts),wadj_c(maxneighbors,maxpmts),low_c(maxpmts), &
	&high_c(maxpmts)
	integer :: npmts_c,camera_c
	real :: xseg_c,yseg_c,xoff_c,yoff_c,x_c,y_c,rad_c,wadj_c,low_c,high_c

	character(LEN=200),parameter :: chform_c=   &
	&'npmts_c[0,'//cmaxpmts//'],camera_c:I,xseg_c:R,yseg_c:R,&
	&xoff_c:R,yoff_c:R,&
	&x_c(npmts_c):R,y_c(npmts_c):R,rad_c(npmts_c):R,&
	&wadj_c(8,npmts_c):R,&
	&low_c(npmts_c):R,high_c(npmts_c):R'

        character(LEN=4),parameter :: chblock_c='c_im'

	
!Now define the area ntupple
!Maximum sky pixels comes from itheta_max=8 for whipple. we use 5 phi steps
!but lets assume 6 for safty=>maxskypixels=6*(8*(8+1)/2)+1=217
	integer,parameter:: maxskypixels=217
	character(LEN=3),parameter :: cmaxskypixels='217'
	common/a_im/ntrig_a,nx_a,ny_a,tep_a,id_a,itype_a,&
	&itheta_a(maxskypixels),iphi_a(maxskypixels),nt_im_a,nt_pe_a,ev_num_a
	integer ntrig_a,nx_a,ny_a,id_a,itype_a,itheta_a,iphi_a,nt_im_a,&
	&nt_pe_a,ev_num_a
	real :: tep_a
	
	character(len=150),parameter :: chform_a=     &
	&'ntrig_a[0,'//cmaxskypixels//'],nx_a:I,ny_a:I,tep_a:R,id_a:I,&
	&itype_a:I,itheta_a(ntrig_a):I,iphi_a(ntrig_a):I,nt_im_a:I,&
	&nt_pe_a:I,ev_num_a:I'

        character(len=4),parameter :: chblock_a='a_im'

!Now define the image ntupple
	common/i_im/npmts_i,adc_i(maxpmts),width_i,length_i,dist_i,alpha_i,&
	&shape_i,orient_i,xmean_i,ymean_i,sdevxy_i,alph_i,asym_i,psi_i,    &
	&maxp_i(4),clstr_i(4)
	integer :: npmts_i,adc_i,shape_i,orient_i
	real :: width_i,length_i,dist_i,alpha_i,xmean_i,ymean_i,sdevxy_i,alph_i
	real :: asym_i,psi_i
	real :: maxp_i,clstr_i

	character(len=220),parameter :: chform_i=   &
	&'npmts_i[0,'//cmaxpmts//'],adc_i(npmts_i):I,width_i:R,length_i:R,&
	&dist_i:R,alpha_i:R,shape_i:I,orient_i:I,xmean_i:R,ymean_i:R,&
	&sdevxy_i:R,alph_i:R,asym_i:R,psi_i:R,m2_i:R,m3_i:R,m4_i:R,m5_i:R,&
	&c2_i:R,c3_i:R,c4_i:R,c5_i:R'                                          
        character(len=4),parameter :: chblock_i='i_im'

	integer :: event_count
	public :: image_init
	public :: image_proc
	public :: image_terminate

CONTAINS
!****************************************************************************
!		IMAGE Ntupple Definitions
!****************************************************************************
!	We write out 3 types of ntupples for the PIXEL.KUMAC macro:
!	NT=1:CWN: parameters that describe the camera and stuff that only 
!		only needs to be read once. Do as a single row CWN since we
!		want to put in arrays.(_c)
!	NT:2:CWN: This the area trigger ntupple. There is on record for each
!		nx,ny area that fires. Besides giving the infor particular to
!		the shower(tep,id etc) it also points to the image 
!		ntupples for each itheta,iphi trigger. Since the number varies
!		area to area we use the CWN to save space. (_a)		 
!	NT:3-9999:CWN: There is one of these for each area that triggers. Its
!		NT value is stored in the AREA Trigger ntupple described above.
!		There is one row int this ntupple for each itheta,iphi
!		combination that triggers. Itheta and iphi are in the AREA
!		trigger ntupple. CWN are used so we can save the largew size
!		adc array as a single variable. RWN have a 512 variable limit.
!		(_i)
!****************************************************************************


    SUBROUTINE IMAGE_INIT(wptr,pptr)
!****************************************************************************
!Open the ntupple file(this is the first call to ntupple_cwn_image) and define
!the camera ntupple(ntnew=1)
!****************************************************************************

!	Modified:

!	09/2/98 GHS V:1:1:5:1:1:1.1
!		Convert to F90.

	use wcamera_def
	use kasaomega_def
	use record_defs
	IMPLICIT NONE

	type(camera) :: wptr
	type(camera_ptrs) :: pptr
	integer nt_old,nt_new
	integer i,j

	npmts_c=wptr%npmt
	nt_new=1		!Open IM_NT file and create ntupple #1 in it.
	nt_old=0		!Don't close anybody
	call ntupple_cwn_image(nt_new,nt_old,chblock_c,npmts_c,chform_c)

!Now load up the only row that goes into this ntupple
	if(wptr%camera_id == "37")then
		camera_c=109
	elseif(wptr%camera_id == "109")then
		camera_c=109
	elseif(wptr%camera_id == "151")then
		camera_c=151
	elseif(wptr%camera_id == "270")then
		camera_c=270
	elseif(wptr%camera_id == "331_125")then
		camera_c=331125
	elseif(wptr%camera_id == "331_1875")then
		camera_c=3311875
	elseif(wptr%camera_id == "331_25")then
		camera_c=33125
	elseif(wptr%camera_id == "490")then
		camera_c=490
	elseif(wptr%camera_id == "1024")then
		camera_c=1024
	elseif(wptr%camera_id == "541")then
		camera_c=541
	elseif(wptr%camera_id == "499")then
		camera_c=499148
	else
		print*,' IMAGE_INIT-Fatal-Unknown Camera ID'
		stop
	endif

	xseg_c=mhead%pe_head%xseg  !X(e-w)
	yseg_c=mhead%pe_head%yseg  !X(e-w)
	xoff_c=mhead%pe_head%x_offset
	yoff_c=mhead%pe_head%y_offset
	x_c(1:npmts_c)=pptr%camera_x				!Vector Arith.
	y_c(1:npmts_c)=pptr%camera_y				!Vector Arith.
	rad_c(1:npmts_c)=pptr%pmt_radius			!Vector Arith.
	low_c(1:npmts_c)=pptr%low		       		!Vector Arith.
	high_c(1:npmts_c)=pptr%high		    	        !Vector Arith.

	wadj_c=0				!Init		!Vector Arith.
	do i=1,npmts_c
		do j=1,wptr%neighbor
			wadj_c(j,i)=pptr%wadjacent(j,i)		
		enddo
	enddo

!And write it.
	call hfnt_(1)
!and close if
	nt_new=0		!Don't open anybody
	nt_old=1		!Write out #1 to file.
	call ntupple_cwn_image(nt_new,nt_old,chblock_c,npmts_c,chform_c)

!	Set nx_a,ny_a,tep_a,id_a way out of any possible real values so
!	that we begin with the first event.
	nx_a=-1000000
	ny_a=-1000000
	tep_a=0
	id_a=0
	nt_im_a=2	!nt=3 is first one.
	nt_pe_a=0
	event_count=0
!	Create the area ntupple
	nt_new=2
	nt_old=0
			!Associate area ntupple(#2) with IM_NT
	call ntupple_cwn_image(nt_new,nt_old,chblock_a,ntrig_a,chform_a)
!And for the image ntupple(needed so the variable length adc array works)
	npmts_i=wptr%npmt
    END SUBROUTINE IMAGE_INIT
!****************************************************************************

    SUBROUTINE IMAGE_PROC(mhead,mrec,hrec,disc_trigger,adc,hntp,  &
			& disc_pulse_height)
!*****************************************************************************

	use structures
	IMPLICIT NONE

	real,dimension(:),pointer :: disc_trigger
	real,dimension(:),pointer :: disc_pulse_height
	real,dimension(:),pointer :: adc
	type(m_head) :: mhead
	type(m_rec) :: mrec
	type(hillas) :: hrec
	type(h_ntp) :: hntp

	integer :: nt_new,nt_old
	logical :: shape,orientation,itrig_exceed=.false.
	integer :: i,ntrig_tot=0

!Protons only debug!
!	if(mrec%nx<-15.or.abs(mrec%ny)>15.or.mrec%itheta>1)then
!	if(mrec%nx>-10.or.abs(mrec%ny)>30)then
!		return
!	endif

	if(itrig_exceed)then
		return
	endif

 	if(hrec%dist>.0)then
		call standard_supercuts(hrec,shape,orientation)
	else
		shape=.false.
		orientation=.false.
	endif
		
	event_count=event_count+1
!We have a trigger to save to the image file.
!first see if this is a new are(and/or new shower)
	if(mrec%nx.ne.nx_a.or.mrec%ny.ne.ny_a.or.		&
	& mhead%pe_head%segment_head%tep.ne.tep_a.or.           &
	& mhead%pe_head%segment_head%idfile.ne.id_a)then
					!New area.See if there is a previous
					!one to write out.Note we can only
					!write out the area record when we are
					!done with an area.
			if(tep_a.ne.0)then	!Tep is initally 0
				call hfnt_(2)	!Write area row to PAWC.
						!Close image ntupple for this
						!area
				nt_new=0		!Don't open anybody
				nt_old=nt_im_a		!Write out this one
				call ntupple_cwn_image(nt_new,nt_old, &
			& chblock_i,npmts_i,chform_i)
				if(nt_im_a.eq.9999)then
				    print*,' Ran out of ntupple room for areas'
		   		    itrig_exceed=.true.
				    return
				endif
			endif
					!init next area row.
			ntrig_a=0
			nx_a=mrec%nx
			ny_a=mrec%ny
			tep_a=mhead%pe_head%segment_head%tep
			id_a=mhead%pe_head%segment_head%idfile
			itype_a=mhead%pe_head%segment_head%itype
			nt_im_a=nt_im_a+1	
 			ev_num_a=event_count    	!First event number.
					!Open new image ntupple
			nt_new=nt_im_a		!Create this one
			nt_old=0		!don't Close anybody
	      call ntupple_cwn_image(nt_new,nt_old,chblock_i,npmts_i,chform_i)

		endif
!Put this event into the area row
		ntrig_tot=ntrig_tot+1
		if(ntrig_tot>250)then
			itrig_exceed=.true.
			print*,' Number of images exceeds 250'
			print*,' No more put into file'
		endif
		ntrig_a=ntrig_a+1
		itheta_a(ntrig_a)=mrec%itheta
		iphi_a(ntrig_a)=mrec%iphi
!now set up for the image ntupple row
!Give -sign if part of trigger.
		do i=1,npmts_i
		       	adc_i(I)=adc(i)
!		       	adc_i(I)=disc_pulse_height(i)
			if(adc_i(i).lt.0)then
				adc_i(i)=0
			endif
 			if(disc_trigger(i).ne.0)then
				adc_i(i)=-adc_i(i)
			endif
		enddo
		dist_i=hrec%dist
		if(dist_i/=-1.0)then
 			width_i=hrec%width
			length_i=hrec%length
			alpha_i=asind(abs(hrec%miss/hrec%dist))
			if(shape)then
				shape_i=1
			else
				shape_i=0
			endif
			if(orientation)then
				orient_i=1
			else
				orient_i=0
			endif
			xmean_i=hrec%xmean
			ymean_i=hrec%ymean
			sdevxy_i=hrec%sdevxy
			alph_i=hrec%alph   
			asym_i=hrec%asym
			psi_i=hrec%psi
		else
 			width_i=0
			length_i=0
			alpha_i=0
    			shape_i=0
			orient_i=0
			xmean_i=0
			ymean_i=0
			sdevxy_i=0
			alph_i=0
			asym_i=0
			psi_i=0
		endif					
		do i=1,4
			maxp_i(i)=hntp%max_pe(i)
			clstr_i(i)=hntp%clstr_thrsh(i)
		enddo
!	Now write it out
	call hfnt_(nt_im_a)
	return
    END SUBROUTINE IMAGE_PROC
!******************************************************************************

    SUBROUTINE IMAGE_TERMINATE
!******************************************************************************
!	Finish up and close in a nice way all the imagew related nutpples.
!******************************************************************************
	IMPLICIT NONE

	integer :: nt_old,icycle

	call hcdir_('//IM_NT',' ')
	nt_old=2
	call hrout_(nt_old,icycle,' ')
	nt_old=nt_im_a
	call hrout_(nt_old,icycle,' ')
	call hldir_(' ',' ')
	call hrend_('IM_NT')
    END SUBROUTINE IMAGE_TERMINATE
!******************************************************************************

    SUBROUTINE NTUPPLE_CWN_IMAGE(ntnew,ntold,chblock,iv,chform)
!******************************************************************************
!	This routine opens,closes and defines a CWN.
!******************************************************************************

!	See HBOOK manual pg 25-26.--CALL HBNAME_
!	The very first call to this routine opens the ntupple file whose name
!	is held in DCL variable IMAGE_NTFILE. This file is assigned to //lun2
!	(Thats a hbook designation)

!	NTNEW is the ntupple id of the new ntupple to open.If 0 nothing is
!	opened.

!	NTOLD is the ntupple id of an old ntupple that is to be closed. If 0
!	nothing is closed.

!	CHBLOCK is a character string with the name of the common block the
!	variables are in that define this block. (It could really be any name
!	but I'm using the convention its the name of the common block). All
!	such common blocks are in kasaomega.inc.

!	IV is the first variable described in CHFORM. For now IV must be
!	integer. All other varibles must follow defualt type cconvention or 
!	explicitly typed in CHFORM. For that see HBOOK manulal pg 26.

!	CHFORM is a character string describing the variables to be loaded
!	into a row. The variables are in the order that they are in  in the
!	common block named in CHBLOCK. See HBOOK manaual page 26 for
!	explanation of variable length arays.


!	To Increase max number of records to maximum zera allows
!	which is 64 k (default=32000)
!	Requires 'Q' option in HROPEN_ and setting of RZ variable
!	IQUEST(10) in RZ common are QUEST.
!	If this value is too small one gets the error:
!	      'RZOUT . Request exceeds quota'	
!	May also be able to increase record size to solve this kind
!	of problem.
!****************************************************************************
!		PAW FAQ says:
!****************************************************************************
!PAW FAQ !!!!!!!!!!!!!!!!!!!!!!!!
!It may happen with the current versions of HBOOK/PAW that large ntuples
!give problems if the following process is not followed. To create large Ntuple
!files, you can : 
!
!CALL HROPEN_ with a large value of LRECL (ex LRECL=4096 instead of
!1024) and you can get files 4 times bigger.
!
!When you do that, do not forget in PAW (in Hi/File) to specify the LRECL
!parameter.
!
!If changing LRECL is not sufficient, you can also specify the option Q in
!CHOPT and in IQUEST(10) (COMMON/QUEST/IQUEST(100)) give the
!maximum number of records (current default is 32000 records in CERNLIB
!94A)
!
!Example: 
!
!    COMMON/QUEST/IQUEST(100)
!    IQUEST(10)=64000
!    CALL HROPEN_(lun,......,'NQ',4096,istat)
!
!will create a file with a maximum of 64000 records of 4096 words.
!To minimize the number of keys in the HBOOK/RZ directory, you can also
!increase the buffer size for your ntuple.
!If it is a CWN created by HBNT_/HBNAME_
!Set the buffer size for each column via CALL HBSET_('BSIZE',nwords) A
!convenient value for nwords is the record size itself (eg,4096 words)
!PAW FAQ !!!!!!!!!!!!!!!!!!!!!!!!
!****************************************************************************

!	Modified:

!	12/2/98 GHS	Convert to F90

!	29/6/99 GHS V:1:1:5:1:2:1.7
!		Replace the use of the VMS system call lib$get_symbol with
!		the CERN lib call to GETENVF. This is a call that interfaces
!		with the C routine GETENV. Do this to provide protability to 
!		UNIX/LINUX. 

	use structures
	IMPLICIT NONE

	character(*) :: chform
	character(len=4) ::  chblock
	integer :: ntnew,ntold,iv,itfirst=0

	real,dimension(h_ntp_size) ::  ntp_h
	type(h_ntp) :: hntp
	common/ntp/hntp
	equivalence (ntp_h,hntp)

	integer,dimension(100) :: iquest
	common/quest/iquest

	real,dimension(2000000) :: paw
	common /pawc/paw	!for ntuple creation

	integer,dimension(40) :: islate
	common /slate/islate	!For CERN C libray interface functions.

	integer :: lrec=4096,lsize,ifirst,istat,icycle,i

	character(len=80) :: filename


!	First open the ouput ntupple file if not opened yet.(These are all 
!	hbook commands.) Many ntupples can (and will) be put into this file.
!
!Note: HLIMIT must be called only once in a program. We put it in the main
!	program:	call hlimit(2000000)	!Defines maximum total size of PAWC
!	If its called twice things srew up!!!!!!!

	if(itfirst.eq.0) then
!		call getenvf('IMAGE_NTFILE',filename)
		filename='image.ntpl'
                islate(1)=10
                if(islate(1)==0)then
			stop ' IMAGE_NTFILE is not defined'
		endif
		iquest(10)=64*1024-1	!Set max number of records in ntupple
					!file. Default is 32000 blocks.
		call hropen_(2,'IM_NT',filename,'NQ',lrec,istat)
					!Open unit 2, with arbitrary 
					!HBOOK name:'IM_NT'
					!file name from 'p2'
					!File is 'N'ew file
					!1024=lrec.Block size(recomended)
		if(istat.ne.0)then
			print*,' istat:',istat
			print*,' filename:',filename
			stop 'hropen_ problem'
		else
			print*,' IMAGE NTUPLE opened OK!'
			itfirst=1
		endif
		call hbset_('BSIZE',4096,istat)
	endif


!NOW see if we are asked to close an old ntupple.
	if(ntold.ne.0)then
		call hrout_(ntold,icycle,' ')
		call hcdir_('//PAWC',' ')  	!Remove from memory also.
		call hdelet_(ntold)
	endif

!NOW see if we are asked to define a new ntupple.
	if(ntnew.ne.0)then
 		call hcdir_('//IM_NT',' ')
		call hbnt_(ntnew,'KASCADE',' ')
		call hbname_(ntnew,chblock,iv,chform)
					!ntuple id is ntnew
					!Block Name is in CHBLOCK
					!CHFORM=names of the varables
	endif
	return
    END SUBROUTINE NTUPPLE_CWN_IMAGE
!****************************************************************************

    SUBROUTINE STANDARD_SUPERCUTS(hrec,shape,orientation)
!*****************************************************************************
!	Make the Standard Supercuts!
!*****************************************************************************

	use structures
	IMPLICIT NONE

	type(hillas) :: hrec
	logical shape,orientation
	real :: alpha
		!Shape
	real,parameter :: wsc_dist_l=.51 !Dist low limit(deg in focal plane)
	real,parameter :: wsc_dist_h=1.1 !Dist high limit(deg in focal plane)
	real,parameter :: wsc_width_l=.073 !Width low limit(deg in focal plane)
	real,parameter :: wsc_width_h=.15  !Width high limit(deg in focal plane)
	real,parameter :: wsc_LENGTH_l=.16 !LENGTH low limit(deg in focal plane)
	real,parameter :: wsc_LENGTH_h=.3 !LENGTH high limit(deg in focal plane)
		!Orentation	(dist as above)
	real,parameter :: wsc_alpha_h=15.0 !Alpha high limit(deg in focal plane)

	shape=.true.
 	orientation=.true.
				  !SHAPE
	if(hrec%dist.lt.Wsc_dist_l)then			               !DIST
		shape=.false.
 		orientation=.false.
	elseif(hrec%dist.gt.wsc_dist_h)then
		shape=.false.
 		orientation=.false.
  	elseif(hrec%width.lt.wsc_width_l)then			       !WIDTH
		shape=.false.
	elseif(hrec%width.gt.wsc_width_h)then
		shape=.false.
	elseif(hrec%length.lt.wsc_length_l)then			       !LENGTH
		shape=.false.
	elseif(hrec%length.gt.wsc_length_h)then
		shape=.false.
	endif
				  !ORIENTATION.	(DIST already checked above)
								       !ALPHA
 	if(hrec%dist.ne.0)then
		alpha=asind(abs(hrec%miss/hrec%dist))
		if(alpha.gt.wsc_alpha_h)then
			orientation=.false.
		endif
	endif
	return
    END SUBROUTINE STANDARD_SUPERCUTS
!*****************************************************************************

END MODULE IMAGE
