//VTrig.cpp
//Methods for kasArrayTrigger classes


#include "kasArrayTriggerClasses.h"
// **********************************************************************

int  ArraySpecs::findNX(float x)
{
 //convert to triangular array indicess.
  //This supposedly works for both NS and EW arrays.(The 10000 is for round 
  //down worries. We alwyas want to round more negative.)
  int nx=(int)(x/xSeg+.5+100000.);
  return nx-100000;
}
// **********************************************************************

int  ArraySpecs::findNY(float y,int nx)
{
 //convert to triangular array indicess.
  //This supposedly works for both NS and EW arrays.(The 10000 is for round 
  //down worries. We alwyas want to round more negative.)
  //This code for NS arrays(see notes in kasArrayTrigger.cpp).
  int n=nx/2; //Looking for round down here if nx odd.
  if(n*2==nx)
    {
      //even
      int ny=(int)(y/ySeg+.5+100000.);//.5 puts us in center.
      return ny-100000;
    }
  else
    {
      int ny=(int)(y/ySeg+.5+100000.);//.5 puts us in center.
      return ny-100000;
    }
}

// **********************************************************************

bool ArraySpecs::centerEven(int nx, unsigned short config)
  // ********************************************************************
  //  Determine if center is even or odd nx.
  // *********************************************************************
{
  bool nxEven=false;
  int n=nx/2;
  if(n*2==nx) nxEven=true;
  // since spacing from 0 to 1 and 6 is 
  //always eve Center area follows even/odd of this area.
  if(config==0 || config==01 || config==0100) //Telescope 0,1,6 
    {
      return nxEven;
    }
  else                    //Telescope 2,3,4,5
    {                     // see if 1/2 spacing even.
      int m=arraySpacing/4;
      if(m*2==(arraySpacing/2))
	{
	  return nxEven;
	}
      else
	{
	  return !nxEven;
	}
    }
}

// **********************************************************************

ArrayOffsets::ArrayOffsets( unsigned int configuration, int arraySpacing,
                          			   bool even)
// **********************************************************************
//  Make up the relative offset array for the grid search. These array
//just tell us where we should look for telescopes realtive to the 'reference'
//one.
//For now we put z at 0 always. May change if we need to fix timing.
//The forth word is the bit in the configurtion for the refernece area
//See notes at the begining of the kasArrayTrigger.cpp file
// **********************************************************************
{
    //Telscope configuration assignments:
    //VERITAS-4 just uses 0,1,2,3
    //       3     4
    //
    //    6     0     1    E->
    //
    //       2     5        
  //To generate all the telescope offsets we need only 4 step sizes.
  //arraySpacing defines basic spacing of array. Its also the step size in
  //x from the center to both the east most(tel#1 and west most(tel#6) 
  //telescope(see picture above)
  //nSTepX is the step(+/-) to the x coords of telescopes #2,3,4 and 5
  //Its always arraySpacing/2 (which is why arraySpacing must always be even.
  //For the Y positive offset(to telscopes #3 and 4)  we have nStepy
  //Its value depends if the center is on an even or odd colume and it
  //depends if the column the tlescopes are on (3,4) is even or odd.
  //4 ways to do that.
  //the offset to go down to telescopes 2 and 5 is set in negStepY, Its also
  //different for the for combinations of even/odd and it is different from
  //nStepY becuase of how the odd colums are always shifted up 1/2 a step.
  // ************************
     //Note: xseg and yseg were chosen so that this scheme puts all telescopes
     //exactly xseg*arraySpaceing from their neighbors. ie Telescope 4 is 
     //the same 
     //distance from telescope 0 as it is to telescope 1 which is the same 
     //spacing as telescope 0 to telescope 1.
  // ************************
 //First requirement is that arraySpacing be even. Ie divisable by 2.
  //This means that telescope spacing is mutiple of 2*xseg
  //See notes in kasArrayTrigger.cpp why we do that.

  int nStepX=arraySpacing/2;

  //Now generate the offsets for this spacing.
  //We start by placing the central telescope on coordinates 0,0.
  //We need to check to see if this places the center on an even or an odd
  //colume(assumes 'NS' here)
  int nStepY;
  int negStepY;


// ************************************************************
   //FIRST: Array for when center is on even colum(nx even)
  int n=nStepX/2;  //We want round down here if nStepX is odd.
  if(even)   //We are asking for the offsets when the center colum is even 
             //(ie not shifted up 1/2 yseg
    {
      if(n*2==nStepX)
	{
	 //All telescopes on even columns: nStepX=2,4,6...
	  nStepY=(nStepX/2)*3;//This is tricky but it works. Just check
                             //nStepX=2->nStepY=3,nStepX=4->nStepY=6 etc.
	  negStepY=-nStepY;  //negative distance the same.
	}
      else
	{
	 //Center on even East and West on even,but telescopes 2345 on odd
	 //this means we start 1/2 step up already on 2,3,4,5
	  nStepY=1+((nStepX-1)/2)*3;//nStepX=1->nStepY=1,nStepx=3->nStepY=4
	                            //nStepX=5->nStepY=7...
	  negStepY=-nStepY-1;  //Since odd shifted up need extra step down.
	}
    }
  else
    {                       //center on odd column
      if(n*2==nStepX)
	{
	 //All telescopes on odd. (same as all telescopes even)
	                           //nStepX=2,4,6...
	 nStepY=(nStepX/2)*3;//This is tricky but it work. Just check
	                     //nStepX=2->nStepy3,nStepX=4->nStepy=6 etc.
	  negStepY=-nStepY;
	}
      else
	{
	  //center on odd,East and West on odd, telescopes 2345 on even
	  nStepY=2+((nStepX-1)/2)*3;//nStepX=1->nStepY=2,nStepx=3->nStepY=5
	  negStepY=-nStepY+1;
	}
    }


    //Telscope configuration assignments:
    //VERITAS-4 just uses 0,1,2,3
    //       3     4
    //
    //    6     0     1    E->
    //
    //       2     5        
  //Now fill in the first array offsets
  //Put the central  detector at 0,0
  //Only put in those detectors in configuration.
//kassrtmrg:    Areas are sorted with ny varying fastest and then nx.

  int j=0; //index to telescopes.

  //note:Telescopes numbered 0-6, configuration bits numbered 1-7
    //EAST Telescope(1). Always first one.
  if(configuration & 02)                      //02 is octal 2 =bit 2
    {
      offset[0][j]=arraySpacing;   //x
      offset[1][j]=0;          //y
      offset[2][j]=0;          //z
      offset[3][j]=02;
      j++;
    }

    //NorthEast Telescope(4)
  if(configuration & 020)                      //020 is octal 20 = bit 5
    {
      offset[0][j]=nStepX;
      offset[1][j]=nStepY;
      offset[2][j]=0;
      offset[3][j]=020;
      j++;
    }
    
  //SouthEast Telescope(5)
  if(configuration & 040)                     //040 is ocal 40 = bit 6
    {
      offset[0][j]=nStepX;
      offset[1][j]=negStepY;                  //go down in y.
      offset[2][j]=0;
      offset[3][j]=040;
      j++;
    }

     //Central Telescope(0)
  if(configuration & 01)                      //01 is octal 1 = bit 1
    {
      offset[0][j]=0;
      offset[1][j]=0;
      offset[2][j]=0;
      offset[3][j]=01;
      j++;
    }
    //NorthWest Telescope(3)
  if(configuration & 010)                      //bit 4
    {
      offset[0][j]=-nStepX;
      offset[1][j]=nStepY;
      offset[2][j]=0;
      offset[3][j]=010;
      j++;
    }
    //SouthWest Telescope(2)                    //bit 3
  if(configuration & 04)
    {
      offset[0][j]=-nStepX;
      offset[1][j]=negStepY;
      offset[2][j]=0;
      offset[3][j]=04;
      j++;
    }
    //West Telescope(6)
  if(configuration & 0100)                     //octal 0100 = bit 7
    {
      offset[0][j]=-arraySpacing;
      offset[1][j]=0;
      offset[2][j]=0;
      offset[3][j]=0100;
      j++;
    }
  numberOfTelescopes=j;   

  //WE now want to reorder this array; by nx descending and within that ny 
  //descending.Our schema above should have done that but this forces that
  //condition
  reOrder();

  //For speed reasons later we actually want to create numberOfTelescopes
  //arrays where a different telescope in each array is treated as the center.
  for(int iref=0;iref<numberOfTelescopes;iref++)
    {
      int nxref=offset[0][iref];
      int nyref=offset[1][iref];
      int nzref=offset[2][iref];
      for(int i=0;i<numberOfTelescopes;i++)
	{
	  offsetLoc[0][i][iref]=offset[0][i]-nxref;
	  offsetLoc[1][i][iref]=offset[1][i]-nyref;
	  offsetLoc[2][i][iref]=offset[2][i]-nzref;
	  offsetLoc[3][i][iref]=offset[3][i];  //Config doesn't change
	}
    }


  //	For GRID search:Find max and mins needed to insure our GRID
  // covers our present search.  Since we never have to look more
  // negative in nx then the nx of our current ref:
  // 	Note:I don't see this right now but assume its true for nxmin.
  // 	Note: h_ntp  sorted    by increasing values by nx then ny.
  // 	      nx varies slowest. 

  //The other limits we can get by searching offsetLoc.
  //There may be some overkill in these limits but that won't
  //matter much.
  //Init for the search	
  nxMax=-1000000;
  nyMax=-1000000;
  nyMin=1000000;
  for(int i=0;i<numberOfTelescopes;i++)
    {
      for(int k=0;k<numberOfTelescopes;k++)
	{
	  if(offsetLoc[0][k][i]>nxMax)nxMax=offsetLoc[0][k][i];
	  if(offsetLoc[1][k][i]>nyMax)nyMax=offsetLoc[1][k][i];
	  if(offsetLoc[1][k][i]<nyMin)nyMin=offsetLoc[1][k][i];
	}
    }
 }

// *********************************************************************

void ArrayOffsets::reOrder()
{
  //	subroutine arrayorder(array,isize,outarray,xseg,yseg,iref)
// This routine reorders the offset array
// Note that array is dimensioned(3,isize) since it also has  z information(used 
// by dynamic tilt?)
  int outarray[4][kMaxNumberOfTelescopes];
      // order(sort) by nx(descending) and within that ny(descending)
      //This is a really dumb way to sort but it works.
      //Start checking second to first.
  outarray[0][0]=offset[0][0];  //x
  outarray[1][0]=offset[1][0];  //y
  outarray[2][0]=offset[2][0];  //z
  outarray[3][0]=offset[3][0];  //config
 
  for(int i=1;i<numberOfTelescopes;i++)
    {
      int nx=offset[0][i];
      int ny=offset[1][i];
      int nz=offset[2][i];
      int config=offset[3][i];
      for(int j=0;j<i;j++)
	{
	  bool swap;
	  if(nx>=outarray[0][j])
	    {
	      if(nx==outarray[0][j])
		{
		  if(ny>=outarray[1][j])
		    {
		      if(ny==outarray[1][j])
			{
			  const char* string=
			    "Fatal--Duplicate areas found in offsets";
			  V_THROW(kasArrayTriggerDuplicateAreas,string);
			}
		      else
			{
			  swap=true;  //swap if nx same and ny greater
			}
		    }
		  else
		    {
		      swap=false;  //No swap nx same and ny smaller
		    }
		}
	      else
		{
		  swap=true;  //SWAP if new one has geater nx.
		}
	    }
	  else
	    {
	      swap=false; //No swap if new one has smaller nx
	    }
	  //Swap them
	  if(swap)
	    {
	      int nxtemp=outarray[0][j];
	      int nytemp=outarray[1][j];
	      int nztemp=outarray[2][j];
	      int configTemp=outarray[3][j];
	      outarray[0][j]=nx;
	      outarray[1][j]=ny;
	      outarray[2][j]=nz;
	      outarray[3][j]=config;
	      nx=nxtemp;
	      ny=nytemp;
	      nz=nztemp;
	      config=configTemp;
	    }
	}
      outarray[0][i]=nx;
      outarray[1][i]=ny;
      outarray[2][i]=nz;
      outarray[3][i]=config;
    }
  //Replace offset with new order.
  for(int i=0;i<numberOfTelescopes;i++)
    {
      offset[0][i]=outarray[0][i];
      offset[1][i]=outarray[1][i];
      offset[2][i]=outarray[2][i];
      offset[3][i]=outarray[3][i];
    }
 return;
}


// **********************************************************************

unsigned int  ArrayOffsets::telescopeNode(unsigned char config)
  // ****************************************************
  // convert config to determine telescope node.
{
  if(config==01)return 0;
  if(config==02)return 1;
  if(config==04)return 2;
  if(config==010)return 3;
  if(config==020)return 4;
  if(config==040)return 5;
  if(config==0100)return 6;
  //Bad telescope index.
  const char* string=
    "Fatal--Telescope Id lookup failed";
  V_THROW(kasArrayTriggerBadTelescopeID,string);
}


// **********************************************************************

VHDF5VTrig::VHDF5VTrig(ArraySpecs* VArr)
{
  VArray=VArr;
  endOfFileReached=false;
  return;
}

//********************************************************

void VHDF5VTrig::postOpenFile()
{
  //********************************************************
  //This overides the virtual dummy postOpenFile in VHDF5RunDataFile (which 
  //VHDF5KascadeRunDataFile inherits from). VHDF5RunDataFile::openFile calls 
  //this after it 
  //has successfully opened the file. 
  //See VHDF5RunDataFile comments for 08/07/03 
  //for explaination why we do it this way.(Mainly Filip says its safer.)
  //********************************************************
  //Throw exception if no KASCADE dataset (tags)
  if(!existsKASCADEDataset())
    {
      const char* string=
	"Fatal--KASCADE Dataset does not exist in input VHDF5 file";
      V_THROW(kasArrayTriggerNoKASCADEDataset,string);
    }

  numberOfEvents=getNumberEventsInKASCADE();
  endOfShowerReached=false;
  endOfFileReached=false;
  indexNextVTrig=0;
  VHDF5Kascade Kascade;
  readKascade(indexNextVTrig,Kascade);
  tepNow=Kascade.getTep();
  showerIDNow=(int)Kascade.getId();
  float attributes[2];
  readKASCADEAttribute(attributes);
  VArray->setXseg(attributes[0]);
  VArray->setYseg(attributes[1]);

  return;
}


// ********************************************************************

bool VHDF5VTrig::getVTrig(int index, VTrig* vTrig)
  //Return value of false indicates that this event belongs to the next shower
  //Or that the end of file was reached. Later case:return false(shower is done),
  // and set endOfFileReached to true.
{
  if(index==numberOfEvents)
    {
      endOfFileReached=true;
      return false;
    }
  VHDF5Kascade Kascade;
  readKascade(index,Kascade); //Read next event from file.
  //Check we havent changed showers.
  if(Kascade.getTep()!=tepNow || Kascade.getId()!=showerIDNow)
    {
      endOfShowerReached=true;
      return false;
    }
  //Load up the VTrig for this event
  int NX=VArray->findNX(Kascade.getX());
  vTrig->setNX(NX);
  int NY=VArray->findNY(Kascade.getY(),vTrig->getNX());
  vTrig->setNY(NY);
  int iThphi = (int)(Kascade.getIThPhi());
  vTrig->setIThphi(iThphi);
  vTrig->setTrigTime(Kascade.getTimeCFD());
  vTrig->setFileIndex(index);  //So we can find this record if we need to 
                                   //copy it out.
  vTrig->clearTested();
  return true;
}

// *****************************************************************

void VStack::fillStack(int nxLast, int nyLast)
{
  // *****************************************************************
  // Fills stack from file until nxLast,nyLast exceeded or shower ends 
  // or file ends.
  // *****************************************************************
  //Note: this leaves us with the last event on the stack PAST nxLast,nyLast!

  int index=input->getIndexNextVTrig();
  VTrig vTrig;
  for(;;)
    {
      if ((areaStack.back()).getNX()>nxLast)
	{
	  return; 
	}
      if(((areaStack.back()).getNX()==nxLast) && 
	 ((areaStack.back()).getNX()> nyLast))
	{
	  return;
	}

      //Get next event
      if(input->getVTrig(index,&vTrig))//Puts in vTrig
                                       //Will set endOfFileReached if it is.
	                               //Will set endOfShowerReached if it is
	{
	  //Put it on the stack
	  areaStack.push_back(vTrig);
	  index++;   //Bump input file read index
	  input->setIndexNextVTrig(index); //Save it
	}
      else
	{
	  return;              //endOfShowerReached and maybe endOfFileReached
	}
    }
}

// *****************************************************************

void VStack::trimStack(unsigned short configuration)
{
  // *****************************************************************
  // Trims events no longer needed from the front of the stack.
  //This invalidates all iterators and must be followed by a new filling
  //of the gird.
  //We trim off all those events where the vTrig::tested word is equal to 
  //the array::configuration word
  // *****************************************************************
  //We start by find the range to delete. we only delete from the front of 
  //the stack until we reach an event that has not been checked in all 
  //configurations.
  deque<VTrig>::iterator posBegin=areaStack.begin();
  deque<VTrig>::iterator pos;
  deque<VTrig>::iterator posEnd;
  for(pos=posBegin; pos!=areaStack.end();pos++)
    {
      if(pos->getTested()!=configuration)
	{
	  break; //We hit one we haven't tested in all positions of the
	         //array yet.
	}
      posEnd=pos;  //We will want to delete up to here at least. See if more.
    }
  if(posBegin!=posEnd)
    {
      pos=areaStack.erase(posBegin,posEnd);
    }
  return;
}

// **********************************************************************

VGrid::VGrid(VHDF5VTrig* in, VStack* stack, ArraySpecs* VArr)
  // **********************************************************************
  //  Instantiate the grid. The grid holds deque position iterators in the
  //  stack which is a deque.
  // **********************************************************************
{
 input=in;
 areaStack=stack;
 VArray=VArr;
 //Define the NULL position.
 NullArea.push_back(nullArea);
 posNull=NullArea.begin();

 for(int i=0;i<kMaxGridSize;i++)
   {
     for(int j=0;j<kMaxGridSize;j++)
      {
	grid[i][j]=posNull;
      }
   }
return;
}

void VGrid::fillGrid(int refNX, int refNY)
// **********************************************************************
//  Fills the grid with the interator pos from the stack.
//  Loads into stack if not enough to cover the grid.
{
  //nxRef and nyRef are nx,ny of [0][0] our grid.
  //First see if stack covers the grid. Stack need to go up to:
  setNXRef(refNX); //Saves in nxRef
  setNYRef(refNY);//Saves ub nyRef
  int nxGridLast=nxRef+kMaxGridSize-1;
  int nyGridLast=nyRef+kMaxGridSize-1;
  areaStack->fillStack(nxGridLast,nyGridLast);

  areaStack->trimStack(VArray->getConfiguration());

  //Stack is filled and trimed.Reload the grid

  //Init grid by Loading with Null area iterators.
  for(int i=0;i<kMaxGridSize;i++)
    {
      for(int j=0;j<kMaxGridSize;j++)
	{
	  grid[i][j]=posNull;
	}
    }
  //go through the stack
  for(deque<VTrig>::iterator pos=areaStack->getBegin();
                                            pos!= areaStack->getEnd();pos++)
    {
      //see if this element is wanted in the grid
      int nx=pos->getNX();
      int ny=pos->getNY();
      //first check were done             .
      if((nx>nxGridLast) || (nx==nxGridLast && ny>nyGridLast) )//right edge
	{
	  break;   //done
	}
      if(nx<nxRef)   //left edge of grid skip this one and go on
	{
	  continue;
	}
	 //Above checks that nx of event is ok. Now check ny
      if(ny<nyRef || ny>nyGridLast)
	{
	  continue;
	}
	 
      //OK the nx,ny of this point is in the grid, 
      //see if we have placed a pos to the ithphi group this event is
      //part of
      int nxRel=nx-nxRef;
      int nyRel=ny-nyRef;
      if(grid[nxRel][nyRel]==posNull)
	{
	  grid[nxRel][nyRel]=pos;
	}
      else
	{
	  continue;
	}
    }
  //Were done.
  return;
}
// *****************************************************************

bool VGrid::contained(int nx, int ny)
  // ***************************************************************
  // Check that all the othere areas we need to check whether this
  //location will is part of an array trigger in any position in the array
  //is contained in the grid.
{
  if(nx-nxRef<0)  //Better be not too small!
    {
      const char* string=
	"Fatal--Illegal Area requested:nx<nxRef";
      V_THROW(kasArrayTriggerIllegalAreaRequested,string);
    }
  if((nx-nxRef)+nxMax>kMaxGridSize-1)
    {
      return false;
    }
  if((ny-nyRef)+nyMin<0)
    {
      return false;
    }
  if((ny-nyRef)+nyMax>kMaxGridSize-1)
    {
      return false;
    }
  return true;
}
// ***********************************************************************

void VGrid::reMap(int nx, int ny)
  // *********************************************************
  //Remap the grid so that this event is contained.
  //new nxRef will be nx since we never have to go earlier
  //new nyRef depends on where we are.
  //see if we are above
  //If the area range neede to cover nx,ny fits within (0,-kMaxGridSize/2)
  //to (kmMaxGridSize-1,kMaxGridSize/2-1) map the grid to that.
  //else map grid to just cover the new area range.
  //This should give us the fewest remappings.
{
  //Assume we can do standard mapping.
  int nxRefNew=nx;
  int nyRefNew=-kMaxGridSize/2;

  //See if this covers the rang ny needs.
  if( ((ny+nyMin)<nyRefNew) || ((ny+nyMax)>(nyRefNew+kMaxGridSize-1)) )
    {
      nyRefNew=ny+nyMin;  //This could be a little smarter.
                          //redo if performance is a problem.
    }
  if(nxRefNew!=nxRef && nyRefNew!=nyRef)
    {
      fillGrid(nxRefNew,nyRefNew);
    }
  return;
}

// ********************************************************************

int VGrid::triggerMultiplicity(int index, deque<VTrig>::iterator pos,
			       ArrayOffsets* offSetPtr, 
			       deque<VTrig>::iterator* posTrigger,
			       unsigned char* triggerMask)
  // ********************************************************************
  // Test to see if an array trigger if we put telescope 'index' at postion
  // pos-getNX and pos->getNY. 
  // ********************************************************************
  //Do this by calculating the nx,ny positions
  //of the other telescope positions, using the offset array.
  //Look up these position is the grid which then points us to the nx,ny 
  //position of the nx,ny group in the stack. Check that within that group
  //is an ithphi match.
  //In this particular form we assume all triggers are within timing of each
  //other and we only have to sum the number of trigger telescopes to 
  //get an array trigger multyiplicity.
  //Its the array multiplicity thats returned.

  //First see if we have already tested this telescope in this position in
  //the array. If so return with multiplicity set to 0(we already tested for 
  //this configuration
{
  if( (pos->getTested()& offSetPtr->getConfig(index))!=0 ) //single bit test
    {
      return 0;  //No new trigger. We already tried this one.
    }
  
  //search by use of offset arrays and grid for an array event.
  //set bit in  configuration of each postion tested.
  int multiplicity=0;
  int iThphi=pos->getIThphi();
  unsigned char tMask[kMaxNumberOfTelescopes];
  for(int i=0;VArray->getNumberOfTelescopes();i++)
    {
      //find pos for this area(0 if no such area)
      int nxTest=pos->getNX()+offSetPtr->getNXOffset(i,index);
      int nyTest=pos->getNY()+offSetPtr->getNYOffset(i,index);
      posTrigger[i]=posArea(nxTest,nyTest,iThphi);
      if(posTrigger[i]!=posNull)
	{
	  tMask[i]=(unsigned char)offSetPtr->getConfig(i);
	  multiplicity++;
	}
      else
	{
	  tMask[i]=0;
	}
      //Flag this area tested. Or in the bit. for this position
      posTrigger[i]->setTested(posTrigger[i]->getTested() |
			                             offSetPtr->getConfig(i));
    }
  triggerMask=tMask;
  return multiplicity;
}

// ***********************************************************

deque<VTrig>::iterator VGrid::posArea(int nx, int ny, int iThphi)

  // ***********************************************************
  // See if a trigger happened at nx,ny,ithphi
  // ***********************************************************
{
  //Find start position in stack of the nx,ny group from the grid.
  int nxGrid=nx-nxRef;
  if(nxGrid<0)  //event is before nx of grid. Which means it doesn't exist
    {
      return posNull;  //return no event
    }
  //We already have assured ourselves that the grid coves all possible nx ny
  //values for nx >0;
  int nyGrid=ny-nyRef;
  deque<VTrig>::iterator pos=grid[nxGrid][nyGrid];
  if(pos==posNull)
    {
      return posNull; //return no event in stack this nx,ny
     }
  //seach now for ithphi
  for(;;)
    {
      //check we still are in correct nx,ny group
      if(nxGrid!=pos->getNX() || nyGrid!=pos->getNY())
	{
	  return posNull; //return no event
	}
      //see if this is the one
      if(iThphi==pos->getIThphi())
	{
	  return pos;   //Return the iterator that poiunts in the deque stack
	                //to the event
	}
      pos++;   //Try again
      if(pos==areaStack->getEnd())
	                       //Remeber end() is iterator position after last.
	{
	  return posNull; //end of stack found and no match
	}
    }
}
