c	Include file for KAS_array_trigger
!	Converted from kasaomega.inc GHS 26/6/98

!	Modified:
!	07/7/98 GHS  1:1:5:1:1:1:1.3
!		Fix the even/odd column problem with veritasloc by relplacing it
!		with two arrays: VERITASLOC_EVEN,VERITASLOC_ODD
!		See the note above about evem/odd columns

	real*8 twopi
	parameter (twopi=6.28318531)

	character*8 namtyp(18)

c        Particle names.
        data namtyp/'Gamma   ','Positron','Electron','Mu +    ',
     1 'Mu -    ','PI 0    ','PI +    ','PI -    ','K +     ',
     2 'K -     ','K long  ','K short ','Proton  ','Neutron ',
     3 'eNeutrin','anti-eNu','muNeutri','ant-muNu'/

	common/inp/area,hmult,swindow,
	1 pe_threshold,new_noise,new_reflectivity,new_trigger,detector,
	1 options,hadron
	integer hmult
	
	real pe_threshold,new_noise,new_reflectivity
	character*40 options
	character*4 detector
	logical*1 hadron,new_trigger
	real swindow,area

	include 'kasstructures.inc'

	common/mount/dlm(11,60),dmm(11,60),dnm(11,60),itheta_max,step_size,
	1 x_gplane(v_size),y_gplane(v_size),x_mplane(11,60,v_size),
	2 y_mplane(11,60,v_size),xdlm(11,60),xdmm(11,60),xdnm(11,60),
	1 ydlm(11,60),ydmm(11,60),ydnm(11,60)

	real dlm,dmm,dnm,x_gplane,y_gplane,x_mplane,y_mplane,
	1 xdlm,xdmm,xdnm,ydlm,ydmm,ydnm
	integer itheta_max,step_size                     

	common/results/solid_angle
	real solid_angle(11)

	integer trig_eff_size
	parameter(trig_eff_size=125)
	common/w10m_trig/ w10m_eff
	real w10m_eff(trig_eff_size)


	RECORD/M_HEAD/MHead	   	
	common /mrec/mhead

	RECORD/h_ntp/h_ntp	   	
	common /hntp/h_ntp

	RECORD/v_ntp/v_ntp	   	
	common /vntp/v_ntp


	real pmt_radius
	parameter(pmt_radius=.6496063)	!PMT radius(same as WPMT_SEP in
					!KASTRIG.INC
	real w10m_pe_adccnts		!Conversion ratio  pe's to adc 
!	parameter(w10m_pe_adccnts=.68)	!counts: 20 pe's = (20/.68) adc counts
!					! = 27.2 adc counts
	parameter(w10m_pe_adccnts=1.25)	!counts: 20 pe's = (20/1.25) adc counts
					! = 16 adc counts (From Adrian 9/9/94)


!SUPERCUTS and EARS CUTS
	real wsc_dist_l,wsc_dist_h,wsc_width_l,wsc_width_h,wsc_LENGTH_l,
	1 wsc_LENGTH_h,wsc_alpha_h,wec_distlr_h
		!Shape
	parameter (wsc_dist_l=.51)	!Dist low limit(degrees in focal plane)
	parameter (wsc_dist_h=1.1)	!Dist high limit(degrees in focal plane)

	parameter (wsc_width_l=.073)	!Width low limit(degrees in focal plane)
	parameter (wsc_width_h=.15)	!Width high limit(degrees in focal 
					!plane)
	parameter (wsc_LENGTH_l=.16)	!LENGTH low limit(degrees in focal 
					!plane)
	parameter (wsc_LENGTH_h=.3)	!LENGTH high limit(degrees in focal 
					!plane)

		!Orentation	(dist as above)
	parameter (wsc_alpha_h=15.0)	!Alpha high limit(degrees in focal 
					!plane)

		!ears
!	parameter (wec_distlr_h=0.2)	!1:Max acceptable distace of image left
!	parameter (wec_distlr_h=0.225)	!2:Max acceptable distace of image left
!	parameter (wec_distlr_h=0.175)	!3:Max acceptable distace of image left
!	parameter (wec_distlr_h=0.15)	!4:Max acceptable distace of image left
!	parameter (wec_distlr_h=0.125)	!5:Max acceptable distace of image left
	parameter (wec_distlr_h=0.275)	!6:Max acceptable distace of image left
					!ear to right ear.

!Stuff for 109 modeling.
	real pe_dc109
	parameter (pe_dc109=1.0)     !Normal 10m 109 pixel setup(i guess?!)

	common /w10m109/w109_img_sig,phwidth_factor
	real w109_img_sig(109)
	real phwidth_factor/0.146/


!Stuff for 541 modeling.
	real pe_dc541
	parameter (pe_dc541=1.0)     !Normal 10m 109 pixel setup(i guess?!)
!	parameter (pe_dc541=.5)      !For Chuck. Increased resolution of ADC's
!	parameter (pe_dc541=.25)      !For Chuck. Increased resolution of ADC's

	common /w10m541/w541_img_sig
	real w541_img_sig(541)


	integer max_stack,max_grid
!Searchlite
	real array_spacing

	parameter(array_spacing=10.0)	!10m spacing to start.
	parameter (max_stack=150000)
	parameter (max_grid=300)

!veritas
	common/veritas/veritas_array_even,veritas_array_odd,
	1 veritasloc_even,veritasloc_odd,center_index,
	1 v_eof,v_beg_of_shower
	real veritas_array_even(3,v_size),veritas_array_odd(3,v_size)
	integer veritasloc_even(2,v_size,v_size),
	1 veritasloc_odd(2,v_size,v_size),center_index
	logical v_eof,v_beg_of_shower

	integer nth,ntv
	parameter (nth=1)
	parameter (ntv=2)

!	parameter (nth=2)
!	parameter (ntv=1)
	
	common/mult/mrecord,itop,ibottom,link_list,record_length
	real mrecord(m_size,max_stack),record_length
	integer*4 link_list(11,60)
	integer itop,ibottom

	common/gridd/grid,nxmax,nymax,nymin,ngxref,ngyref
	integer grid(0:max_grid,0:max_grid)
	integer nxmax,nymax,nxmin,nymin,ngxref,ngyref
	
	structure/trigger/
		record/m/m(v_size)			
	end structure

	logical debug_trigger
!	parameter (debug_trigger=.true.)
	parameter (debug_trigger=.false.)

