       subroutine multscatt(tenergy,tsegment,ispec,dl,dm,dn,qz,xmass)
!***************************************************************************
c      Calculate the angle this particle multiple scatters in the length
c      tsegment and redirect the particle.
!***************************************************************************
!  THIS FILE IS NOW OBSOLETE: REPLACED WITH KASMULTSCATT.CPP
!***************************************************************************

c      tenergy=K.E. of particle at middle of the segment(Tev.)
c      tsegment=length of segment that particle multiple scatters in(Gm/cm**2)
c      ispec=particle species.
c      dl,dm,dn=direction cosigns of the particle.

c      This code replaces the multiple scatter code used in EMS. I'm not sure 
c      how that code worked but I have a suspicion that it has problems. 
c       This formula was taken from the Particle Properties Data Booklet of 
c      April 1984, pg. 112-113(Which is reproduced
c      as a Review of Modern Physics volume.April 1984).  The book
c      claims that this formulation is good to 5% for our regiem and implies 
c      that particle type is unimportant.  Single angle scattering is added 
c      here with a 1/tix**3 distribution.
c      The EMS code seems to have taken a lot
c      of trouble for very small angle scattering.
c      This code is however much faster then the EMS code.

c      6/26/86 G.H.S.       Test tsegment to make sure its positive definate.

!     28/03/01 GHS V:1:1.3
!      Use a better coef value for the multiple scatering width calculation.
!      Use a value of 13.6*sqrt(2)=19.233. This is from Particle Physicis
!      Booklet of 1998 (and all post 1990 we think) pg 184.
!      Thanks to Julien Guy for pointing out this correction.

!	25/06/01 GHS V:1:2.0
!		Modify for use with Heavies. Particle data book says only
!               modification needed is to as a factor of QZ(heavy charge) to
!               the THETARMS calculation. Also, leave in 
!               the single large scatter code(I think this just adjuste 
!               tails of mult scat beyond 5 deg. to something a bit
!               non-gausian. I don't know if this is the best thing to do 
!               for heavies.

!      13/01/05 GHS  V:1:3.5
!               For testing purposes this MULTSCATT routine was moved out of
!               kascade to a file called kasmultscatt.for. the API is the same 
!               as for the eventual replacement file: kasmultscatt.cpp 
!               (derived from VVV's chess.for program)


	real xmass
	integer qz
       include 'kascade.inc' !gets us rad_len

       if(tsegment.le.0)then
              write(6,1000)tenergy,tsegment,ispec,dl,dm,dn
1000  format(' ***Multscatt--Tsegment out of range:',/,
     1' ***(tenergy,tsegment,ispec,dl,dm,dn):',/,' ***',2e14.7,i5,
	1 3e14.7)
              return
              endif

c              First get the gaussian width of the scatter for the particle.
       etev=tenergy+xmass                     !Total energy (tev)
       pbeta=(etev**2-xmass**2)/etev       !P*beta(Tev)
       coef=1.+alog10(tsegment/rad_len)/9.       !coeficient
! GHS 28/03/01
!Correction to MUltiple scatter constant: 
!from Particle data physics handbook 1998
!Thanks to Julien Guy for pointing out this correction.
!pre 1991: thetarms=(19.940*1.e-6/pbeta)*sqrt(tsegment/rad_len)*coef
!post 1991:
! GHS 25/06/01
! For heavies add multiplication by size of charge "abs(QZ)"
       thetarms=(19.233*1.e-6/pbeta)*abs(qz)*sqrt(tsegment/rad_len)*coef
c                     Now pick an angle out of a distribution with this width
c                     Make small angle approx.
       tix=thetarms*sqrt(-2.*alog(pran(xdummy)))

       call geom(dl,dm,dn,tix)              !Go redirect us.

c              Now see if we need to add in a single large angle scatter.
c                            single scattering intoduced here according to
c                            1/tix**3 distribution; for tix gt. 5 deg. only
       timx =63.01*1.e-6/tenergy            !Upper limit on small angle single 
c                                   scattering.
       if(timx.ge..0874)then
c                     If it's at least 5 deg. add in a single large scatter.
              pss=24.26*(131.21-1./timx/timx)/(tenergy*1.e6)**2
c                                   Probability for a large angle scatter        
c                                   in one radiation length.
              pss=tsegment*pss/rad_len              !Prob in this segment.
              if(pran(xdummy).le.pss)then              !See if it happens.
c                            picks random single scattering angle tix1
c                            for energy corresponding to maximum single
c                            scattering angle timx according to a
c                            tix1**(-3) law. not checked for energies
c                            lower than 20 mev. minimum angle 5 deg.
c                            univ.of utah; june 1980
c                            G.H.S. 6/9/86       From EMS program.
1                     r=pran(xdummy)
                     tix1=1./sqrt(r*(131.21+1./timx/timx))
                     if(tix1.gt.timx) go to 1
                     call geom(dl,dm,dn,tix1) !Scatter us.
                     tix=tix1


                  endif
             endif
             write(12,1001)tix
1001        format(e20.10)
       return
       end
