    PROGRAM PST_MULT2HDF5
!******************************************************************************
!     This program converts the binary version os the pst_mult*.dat file into
!     and HDF5 format.  Do this to provide portability of the PST_MULT*.dat
!     files to other platforms.(In particular we are looking at PC LINUX and
!     Alpha LINUX). We will place all three of the PST_MULT files into one
!     HDF5 file.
!******************************************************************************

      IMPLICIT NONE

	integer*2,pointer,dimension(:) :: pst_patterns2
	integer*2,pointer,dimension(:) :: pst_patterns3
	integer*2,pointer,dimension(:) :: pst_patterns4

	integer*2,pointer,dimension(:) :: outpst_patterns2
	integer*2,pointer,dimension(:) :: outpst_patterns3
	integer*2,pointer,dimension(:) :: outpst_patterns4

	integer :: error,ios
	integer,parameter :: n19=2**19
        integer :: i

	external psthdf5_create
	external psthdf5_out
	external psthdf5_close

!******************************************************************************
!     First: Read in the pst_mult files:
!******************************************************************************

 	allocate(pst_patterns2(0:n19-1),stat=error)
	if(error/= 0)then
		print*,"Program could not allocte space for pst_patterns."
	    	stop
	endif
 	allocate(pst_patterns3(0:n19-1),stat=error)
	if(error/= 0)then
		print*,"Program could not allocte space for pst_patterns."
	    	stop
	endif
 	allocate(pst_patterns4(0:n19-1),stat=error)
	if(error/= 0)then
		print*,"Program could not allocte space for pst_patterns."
	    	stop
	endif	

        allocate(outpst_patterns2(0:n19-1),stat=error)
	if(error/= 0)then
		print*,"Program could not allocte space for pst_patterns."
	    	stop
	endif
 	allocate(outpst_patterns3(0:n19-1),stat=error)
	if(error/= 0)then
		print*,"Program could not allocte space for pst_patterns."
	    	stop
	endif
 	allocate(outpst_patterns4(0:n19-1),stat=error)
	if(error/= 0)then
		print*,"Program could not allocte space for pst_patterns."
	    	stop
	endif

!Open input pattern data files and read into buffers
!Use the file that is used on the mountain.

!PST 2:
	open(41,file='pst_mul2.dat',status="OLD",form='binary',iostat=ios)
       	if(ios>0)then
           print*,' file open error for pst_mul*.dat'
           stop 'file open error'
        endif
        read(41)pst_patterns2
	close(unit=41)		


!PST 3:
	open(41,file='pst_mul3.dat',status="OLD",form='binary',iostat=ios)
       	if(ios>0)then
           print*,' file open error for pst_mul*.dat'
           stop 'file open error'
        endif
        read(41)pst_patterns3
	close(unit=41)		

!PST 4:
        open(41,file='pst_mul4.dat',status="OLD",form='binary',iostat=ios)
       	if(ios>0)then
           print*,' file open error for pst_mul*.dat'
           stop 'file open error'
        endif
        read(41)pst_patterns4
	close(unit=41)		
!debug
        if(1.ne.2) then
           print*,' pst2:',(pst_patterns2(i),i=0,15)
           print*,' pst3:',(pst_patterns3(i),i=0,15)
           print*,' pst4:',(pst_patterns4(i),i=0,15)
!           stop
        endif
!debug
!	do i=0,n19-1
!		if(pst_patterns(i)==0)then
!		write(13,4300)i
!4300	format(' ',o14,',')
!		endif
!	enddo
!enddebug
!******************************************************************************

!******************************************************************************
!     Define and aloocate the HDF5 stuff. Use C routines. There
!     is a 'pre-release' version of the FORTRAN interface but I guess I won't
!     use it yet since I would have to install it and make it wrok with
!     the cariious Fortran compilers(Absoft and Compq). I don't want to 
!     spend the time doing that now.
!
!    Most of these calls use my pehdf5 program as a model( Which uses VVV's
!    simtohdf5 as a model).
!******************************************************************************

!        open and create PST_MULT.HDF file.
!	File name PST_MULT. is Linked(ln) to actual file name
!	in calling comand/script file.
!	The our C program that interfaces us to HDF.
!	print*,' Create PST_MULT.HDF file.'
	call psthdf5_create

!******************************************************************************

!******************************************************************************
!       Write out the pst arrays.
!******************************************************************************
        call psthdf5_out(pst_patterns2,pst_patterns3,pst_patterns4)
!******************************************************************************

!******************************************************************************
!      Cleanup, close and leave.
!******************************************************************************
        call psthdf5_close
!******************************************************************************

!******************************************************************************
!      Open the input PST_MULT.HDF file
!      Read in the PST arrays
!      Clenaup and close the HDF file stuff.
!******************************************************************************
        call psthdf5_get(outpst_patterns2,outpst_patterns3,outpst_patterns4)
!******************************************************************************
        do i=0,n19-1
          if(outpst_patterns2(i)/=pst_patterns2(i)) then
              print*,'pst2 failure at i:',i
              stop 'pst2 failure'
          endif
          if(outpst_patterns3(i)/=pst_patterns3(i)) then
              print*,'pst3 failure at i:',i
              stop 'pst3 failure'
          endif
          if(outpst_patterns4(i)/=pst_patterns4(i)) then
              print*,'pst4 failure at i:',i
              stop 'pst4 failure'
          endif
         enddo
         print*,' Pst read success'
         stop
        end
