c	This is a Palfrey addaption of the CERN RANLUX functions
c	for random number generation.
c	Glenn Sembroski Modified it to work with KASCADE.
c	I want to include the RANLUX source code in this file but I can't
c	find it. This means you will have to link anything that uses this
c	with the cern MATHLIB.
c	Unit=3	File where the seed vector is stored.	
ccccccccc
c****************************************************************
c	RANSTART
c****************************************************************
	subroutine RANSTART(random_seed_file_name)
c	Open the seed file and read in the seed vector.
c	Generate first 5000 random numbers.
c	Init random number pointer to 1.

	character*(*) random_seed_file_name

	common/ranvec/rnrs,iseedl,ii
	real*4 rnrs(5000)
	integer*4 iseedl(25),ii,ios
!!debug
!	Print*,' Opening',trim(random_seed_file_name),' for random seed input'
!!enddebug
	open(3,access='sequential',status='old',iostat=ios,
	1 file=random_seed_file_name)
        if(ios>0)then
           print*,' error opening random seed input file',
	1 random_seed_file_name
           stop 'RANDOM seed input file open error'
        endif
	read(3,1000) iseedl
1000	format((5i15))
	close (3)

c	Use a Luxuary level of 3. "Any theorectical possible
c	correlations have very small chance of being observed."
	call rluxgo(3,0,0,0)
	call rluxin(iseedl)
	call ranlux(rnrs,5000)
	ii=1

	return
	end
cccccccccc

c****************************************************************
c	RANEND
c****************************************************************
	subroutine ranend(random_seed_file_name)
c	Open the seed file and save last seed vector there.
c	Init random number pointer to 1.
	character*(*) random_seed_file_name
	common/ranvec/rnrs,iseedl,ii
	real*4 rnrs(5000)
	integer*4 iseedl(25),ii
	integer*4 ios
!debug
!	Print*,' Opening', random_seed_file_name
!enddebug
	open(3,access='append',status='old',iostat=ios,
	1 file=random_seed_file_name)
        if(ios>0)then
           print*,' error opening output random seed file', 
	1	random_seed_file_name
           stop 'Random seed file ouput open faslure'
        endif
	rewind(3)
	call rluxut(iseedl)
	write(3,1000) iseedl
1000	format((5i15))
	close (3)
	WRITE(6,1001) iseedl
1001  	format('   Random seed vector written into file assigned to
	1 for003: ',/,5(' ',5(5i15,/)),/)
	return
	end
cccccccccc

c****************************************************************
c	PRAN
c****************************************************************
	real function pran(xdummy)
c	Give out a random number.
c	Generate new ones if we deplete the present set.
	common/ranvec/rnrs,iseedl,ii
	real*4 rnrs(5000)
	integer*4 iseedl(25),ii
 	ii=ii+1
	if(ii.le.5000) then
		pran=rnrs(ii)
		if(pran>1.0)then
		   print*,'Fatal--PRAN-Random number gen produces pran>1.0'
		   print*,'Probable seed file corruption.pran:',pran
		   stop 'PRAN:pran >1.0'
		endif
		return
	else
		call ranlux(rnrs,5000)
		ii=1
		pran=rnrs(1)
		return
	endif
	end
ccccccccc	

