   SUBROUTINE VERITAS_PEDWIDTHS(wptr,pptr,npmt,adc_gate, ped_width)
!*****************************************************************************
!       This is a wrapper for the C++ function  VeritasPedWidths:
!	It models the sky noise into the FADC and determins the Pedistal width
!       in the FADC data after converting to charge (see PePulseAdc). For use
!       in deremining high /low sigma values for cleanup.
!       This is VERITAS version using C++ classes and functions.
!*****************************************************************************

!	Modified:

!       The main task in this routine is setting up calls to C++ routines
!       to do the work we want. There are a number of arguments that
!       have to be passed (carefully)
	use wcamera_def
	use record_defs
	use structures
	use w10m_pepls_def
        use kasaomega_def
        use w10m_subs
	IMPLICIT NONE

        type(camera) :: wptr
        type(camera_ptrs) :: pptr
	integer :: npmt
	real :: adc_gate
	real,pointer,dimension(:) :: trig_times

!Process the pe into waveforms, cfd trigger times , included Noise as needed.
!PePulseVeritas is a C++ routine.
        call PePulseVeritas(pptr%pes_in_image(ithphi),pptr%time(1,ithphi), &
             & wptr%npmt, pptr%time_pixel(1,ithphi), pptr%active_hv(1), &
             & pptr%disc(1,ithphi),pptr%efficiency(1),pptr%mean_time_gap(1), &
             & pptr%time_trig(1),npmt_trigger,pptr%threshold(1),ntrigger)
		

!We have to have at least hmult triggers before we even start!
        if(ntrigger>=mhead%hmult)then
           mrec%i_mult=ntrigger	      	!Save for ntupple file.
                
!****************************************************************************
!PST analysis
           if(index(mhead%options,'PST')/=0)then 
                     !If we have limnited ourselves to less then 331 pixels in 
                     !trigger they remaining pixels will have the TDC overflow
                     !value(100000.) and thus be ignored in w10m_pst_trigger.
              call w10m_pst_trigger(pptr,trigger_time)
              if(trigger_time/=100000.) then
                 pst_trigger_time=trigger_time
                 pst_event_trigger=.true.
              else
                 pst_trigger_time=100000.
                 pst_event_trigger=.false.
              endif
						!Save for ntupple file.
              mrec%fp_median_time=pst_trigger_time 
           endif
!****************************************************************************

!****************************************************************************
!Multiplicity trigger: Always do it.
			!The multiplicity trigger is generated by a cfd
			!discriminator. So model it as we did the pmt
			!pulses.
			!Note if no trigger will get a trigger at the overflow
			!value of 100000.
           trig_times=>pptr%time_trig(1:npmt_trigger)
           call w10m_mult_trigger(trig_times,mhead%hmult)
				!Save for ntupple file.
           mrec%median_time=mult_trigger_time
           if(mult_trigger_time/=100000.)then
              mult_event_trigger=.true.
           endif
!****************************************************************************
        endif
        if(index(mhead%options,'PST')==0)then 
           pst_event_trigger=.true.	!If were not using PST
                                        !default it true.
        endif
	return
   END SUBROUTINE VERITAS_PEPULSE_ANALYZE
!*****************************************************************************
