
   SUBROUTINE VERITAS_PEPULSE_ADC(wptr,pptr,adc,npmt_trigger)
!*****************************************************************************
!       This is a wrapper for the C++ function  PePulseAdc:
!	It applies the Veritas fadc sampling to the pulse arrays using the 
!       timing to determine the adc values.
!       This is VERITAS version using C++ classes and methods.
!*****************************************************************************
!       modified:
!       08/01/02 GHS V:1:1:6:1:2:3.13
!               This is derived from the W10M_PEPULSE_ADC routine.
!               Cleaned up a bit.

!      12/05/03 GHS V:1:3:8:3:4:4.3
!                Add a call to PePulseADCPrint to veritas_pepulse_adc to print
!                out constants used in FADC.


!       The main task in this routine is setting up calls to the C++ routine
!       PePulseAdc to do the work we want.

!Set up case for name for call to C++ routine.
!dir$ name(pepulseadc="PePulseAdc") 
!dir$ name(pepulseadcprint="PePulsePrintParameters") 

	use wcamera_def
	use structures
	use w10m_pepls_def
	implicit none

        type(camera) :: wptr
        type(camera_ptrs) :: pptr
	real,pointer,dimension(:) :: adc
	integer :: npmt_trigger
	
	real :: trigger_time
        logical :: initialize_adc=.true.

	if(initialize_adc)then
		initialize_adc=.false.
		if(mult_trig_type)then
			write(6,1000)' ADC gate timing set by Multiplicity &
					& trigger'
1000	format(' ',a)
			write(6,1001) ' Multiplcity Trigger fraction:', &
				& 1/mult_cfd_gain
1001	format(' ',a,f10.3)
		else
			write(6,1000)' ADC gate timing set by PST trigger'
		endif
                        !Print out constants used in FADC calculations
                print*,'Calling pepulseprintparameters'
                call PePulsePrintParameters()
	endif

        if(mult_trig_type)then
           trigger_time=mult_trig_time
        else
           trigger_time=pst_trig_time
        endif

        call PePulseAdc(wptr%npmt, npmt_trigger, pptr%active_hv(1), adc(1), &
             & pptr&mean_time_gap(1), trigger_time)

	return
   END SUBROUTINE VERITAS_PEPULSE_ADC
!*****************************************************************************
